import { Component, HostBinding, OnInit } from '@angular/core';
import { Browser,closest, isNullOrUndefined,attributes  } from '@syncfusion/ej2-base';
import { SettingsService } from './core/_services/settings.service';
import * as am4core from '@amcharts/amcharts4/core';
import * as am4charts from '@amcharts/amcharts4/charts';
import am4themes_animated from '@amcharts/amcharts4/themes/animated';
import { DropDownList } from '@syncfusion/ej2-angular-dropdowns';
declare var Stimulsoft: any;

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.scss']
})
export class AppComponent implements OnInit {

    @HostBinding('class.layout-fixed') get isFixed() { return this.settings.getLayoutSetting('isFixed'); };
    @HostBinding('class.aside-collapsed') get isCollapsed() { return this.settings.getLayoutSetting('isCollapsed'); };
    @HostBinding('class.layout-boxed') get isBoxed() { return this.settings.getLayoutSetting('isBoxed'); };
    @HostBinding('class.layout-fs') get useFullLayout() { return this.settings.getLayoutSetting('useFullLayout'); };
    @HostBinding('class.hidden-footer') get hiddenFooter() { return this.settings.getLayoutSetting('hiddenFooter'); };
    @HostBinding('class.layout-h') get horizontal() { return this.settings.getLayoutSetting('horizontal'); };
    @HostBinding('class.aside-float') get isFloat() { return this.settings.getLayoutSetting('isFloat'); };
    @HostBinding('class.offsidebar-open') get offsidebarOpen() { return this.settings.getLayoutSetting('offsidebarOpen'); };
    @HostBinding('class.aside-toggled') get asideToggled() { return this.settings.getLayoutSetting('asideToggled'); };
    @HostBinding('class.aside-collapsed-text') get isCollapsedText() { return this.settings.getLayoutSetting('isCollapsedText'); };

    constructor(public settings: SettingsService) { }

    ngOnInit() {
        // per evitare NavigateStart quando si seleziona
        // un elemento da dropdown in modalità mobile
        (DropDownList as any).prototype.onMouseClick = function (e) {
            const target: Element = e.target as Element;
            const classList: DOMTokenList = target.classList;
            const li: HTMLElement = closest(target, '.' + 'e-list-item') as HTMLElement;
            if (!this.isValidLI(li)) {
                return;
            }
            this.setSelection(li, e);
            if (Browser.isDevice && this.isFilterLayout()) {
                 const delay = 100;
                 this.closePopup(delay);
            } else {
                const delay = 100;
                this.closePopup(delay);
            }
        };

        // questo ulteriore override è necessario per completare il fix
        // di cui sopra: navigando con un dispositivo mobile, se la route
        // corrente è stata attivata utilizzando il navigationExtra "skipLocationChange"
        // e dopo tale navigazione ho aperto un dropdown (appunto, in modalità mobile),
        // grazie a questo override cliccando in seguito su un pulsante che invoca
        // history.back() (tipicamente per il pulsante "Indietro") la navigazione viene
        // riportata correttamente alla route precedente, senza considerare quella attivata
        // utilizzando "skipLocationChange". Senza il fix, l'ultima route attivata viene
        // considerata anche se ho indicato "skipLocationChange", pertanto history.back()
        // non rimanda alla route corretta
        (DropDownList as any).prototype.invokeRenderPopup = function () {
            if (Browser.isDevice && this.isFilterLayout()) {
                const proxy2 = this;
                window.onpopstate = () => proxy2.hidePopup();
            }
            if (!isNullOrUndefined(this.list.children[0]) || this.list.classList.contains('e-nodata')) {
                this.renderPopup();
            }
            attributes(this.targetElement(), { 'aria-activedescendant': this.selectedLI ? this.selectedLI.id : null });
        };

        // prevent empty links to reload the page
        document.addEventListener('click', e => {
            const target = e.target as HTMLElement;
            if (target.tagName === 'A' && ['', '#'].indexOf(target.getAttribute('href')) > -1)
                e.preventDefault();
        });

        //attivazione stimulsoft
        Stimulsoft.Base.StiLicense.Key = "6vJhGtLLLz2GNviWmUTrhSqnOItdDwjBylQzQcAOiHlRKchb2132vJWXPzw1kdW2V/13v7esXY2zHlnTCiHpcbp7KM" + 
        "FlMG9xH9O/4wL9yYWxId03ovkyYPGey8U461+PDuSFwXfXtaikE4kENIWIryc36FS10dfjV4YHr6uVvqxQiPn+7+OC" + 
        "VVV6Sx07mRLmzClcwam/nv6YssAyTmb/ZGi3yJy8wN5tGosRxT43k4MQt9WTs2TR5nx09OVaKQLWhkcqeHMS/D+mb/" + 
        "T4W1lCJMerz+6Rm6dnW6WqVGATAcGwC0rHo6ZUi6vrJKl805p/spAxw34nuTrQzl5BsT4hoNjYEds3B88FwRsAVOe9" + 
        "xVxxQv5j/i8MR4MM4LJc0bUPFfFK4nhmYhA/rSqFQAG3Gm4liXm6x0EM9YiWKFN/jTg1CfIHp3l4kg+Uy/sLZ1S6RT" + 
        "dTN1M3CjBw8QdqXnIGgu84OhqC2ezv3H4wTkVt4Z37+9hvVXl6JGLDSRkPrqEm8R8AOAauLbVQ6oB6Sx25lQjeDSBi" + 
        "JSra5dTbtG32tkwcbUUQpYgmaLKR67iHvrD9zHGpRIC4HKZ5GDRVgmtP1shEWDr8PebFZRI+Pll7tW2CKGxW8ruayf" + 
        "I5VNLzK29DRkGYRbLJa4DlYfCcTznre1ohmARpHuRXPZTI4pbaBtnI76s0Xhxv26eRy959sl31";

        //impostazione tema amcharts
        am4core.useTheme(am4themes_animated);
    }
}
