import { Injectable } from '@angular/core';
import { CanActivate, Router, ActivatedRouteSnapshot, CanActivateChild, RouterStateSnapshot, UrlTree } from '@angular/router';

import { ToasterWrapperService } from '../_services/toaster-wrapper.service';
import { AuthenticationService } from '../_services/authentication.service';
import { Observable } from 'rxjs';

@Injectable()
export class RoleAuthGuard implements CanActivateChild {

  constructor(private authService: AuthenticationService, private router: Router, private toastService: ToasterWrapperService) {}

  canActivateChild(childRoute: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean {

    const rolesKey = 'roles';
    const roles = childRoute.data[rolesKey] as Array<string>;

    if (this.authService.isAuthorized(roles)) {
        return true;
    }

    this.toastService.toastError('Accesso negato. Rivolgersi ad un responsabile.');
    // se l'utente non è autorizzato, mostro semplicemente l'opportuno alert, non è necessario
    // cambiare la route perchè semplicemente quest'ultima non è stata attivata: si rimane automaticamente
    // sull'ultima route valida!
    // this.router.navigate(['']);
    return false;
  }
}
