import { Injectable, Inject, Renderer2, RendererFactory2 } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { DOCUMENT } from '@angular/common';

@Injectable()
export class SitewideSearchService {

  public IsActive = new BehaviorSubject<boolean>(false);

  private renderer: Renderer2;

  constructor(@Inject(DOCUMENT) private document: Document, private rendererFactory: RendererFactory2) { 
    this.renderer = rendererFactory.createRenderer(null, null);
  }

  public toggleSearch(){
    this.IsActive.next(!this.IsActive.value);

    if (this.IsActive.value){
      this.renderer.addClass(document.body, 'no-overflow');
    } else {
      this.renderer.removeClass(document.body, 'no-overflow');
    }
  }

}
