import { Component, OnInit, OnDestroy } from '@angular/core';
import { SpinnerWrapperService } from 'src/app/core/_services/spinner-wrapper.service';
import { Subscription } from 'rxjs';

@Component({
  selector: 'app-spinner-wrapper',
  templateUrl: './spinner-wrapper.component.html',
  styleUrls: ['./spinner-wrapper.component.scss']
})
export class SpinnerWrapperComponent implements OnInit, OnDestroy {

  showSpinner = false;
  showSpinnerSubscription: Subscription = null;

  constructor(private spinnerServ: SpinnerWrapperService) { }

  ngOnInit() {
      this.showSpinnerSubscription = this.spinnerServ.showSpinner.subscribe(shown => {
        this.showSpinner = shown;
    });
  }

  ngOnDestroy() {
    this.showSpinnerSubscription.unsubscribe();
  }

}
