import { ViewCompileResult } from '@angular/compiler/src/view_compiler/view_compiler';
import { Component, OnDestroy, OnInit, ViewEncapsulation } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Subscription } from 'rxjs';
import { CardData, CardGridOptions } from 'src/app/core/_models/card-grid';
import { SettingsService } from 'src/app/core/_services/settings.service';

@Component({
  selector: 'app-home',
  templateUrl: './home.component.html',
  styleUrls: ['./home.component.scss'],
  encapsulation: ViewEncapsulation.None
})
export class HomeComponent implements OnInit, OnDestroy {

  private subscriptions = new Subscription();

  menuDatasource: CardData[];

  public cardGridOptions: CardGridOptions = {
    CardHeight: '300px',
    CardMinWidth: '400px',
    CardTextSize: '2rem',
    CardSubtextSize: '1rem',
    CardBorderRadius: '5rem',
    CardVerticalSpacing: '100px',
    CardHorizontalSpacing: '50px',
    CardPictureMaxHeight: '150px',
    CardPictureMinHeight: '150px',
    CardPictureTopMargin: '20px'
  };


  constructor(private route: ActivatedRoute, private settingsServ: SettingsService) {}

  onElementSelect(evt){

  }

  ngOnInit() {
    setTimeout(() => this.settingsServ.setLayoutHidden(false), 0);

    this.route.data.subscribe((data: { menu: CardData[]}) => {
      console.log(data.menu);
      this.menuDatasource = data.menu;
    });
  }


  ngOnDestroy(){
    this.subscriptions.unsubscribe();
  }
}
