import { LayoutComponent } from '../layout/layout.component';
import { RoleAuthGuard } from '../core/_guards/role-auth.guard';
import { UserPermissions, UserLevels, UserAccesses } from '../core/_services/authentication.service';
import { RequiresOnlineGuard } from '../core/_guards/requires-online.guard';

export const routes = [{
    path: '',
    component: LayoutComponent,
    canActivateChild: [RoleAuthGuard, RequiresOnlineGuard],
    children: [
        { path: '', redirectTo: 'home', pathMatch: 'full' },
        { path: 'home', loadChildren: () => import('./home/home.module').then(m => m.HomeModule) },
    ]},
    // Not found
    { path: '**', redirectTo: 'home' }
];
