import { Component, OnInit, Output, EventEmitter, ViewChild } from '@angular/core';
import { WebcamImage } from 'ngx-webcam';
import { WebcamStandaloneViewerComponent } from '../webcam-standalone-viewer/webcam-standalone-viewer.component';
@Component({
  selector: 'app-webcam-viewer',
  templateUrl: './webcam-viewer.component.html',
  styleUrls: ['./webcam-viewer.component.scss']
})
export class WebcamViewerComponent implements OnInit {

  @ViewChild('standAloneViewer', {static: false})
  standAloneViewer: WebcamStandaloneViewerComponent;

  @Output()
  public snapshotConfirmed = new EventEmitter<string>();

  @Output()
  public closeDialog = new EventEmitter<void>();

  dialogWidthPercentString: string;

  public dialogButtons = [
    { click: this.onTakeSnapshot.bind(this), buttonModel: { content: 'Scatta foto', isPrimary: 'true' } },
    { click: this.showNextWebcam.bind(this), buttonModel: { content: 'Cambia webcam' } },
    { click: this.onChiudi.bind(this), buttonModel: { content: 'Chiudi' } }];


  onDialogWidthPercentStringChanged(newValue: string){
    this.dialogWidthPercentString = newValue;
  }

  onTakeSnapshot(){
    this.standAloneViewer.onTakeSnapshot();
  }

  showNextWebcam(){
    this.standAloneViewer.showNextWebcam();
  }

  onChiudi() {
    this.closeDialog.emit();
  }

  innerOnSnapshotConfirmed(base64Image: string){
    this.snapshotConfirmed.emit(base64Image);
  }

  ngOnInit(){}
}
