import { Directive, HostListener, ElementRef } from '@angular/core';
import { NumericTextBoxComponent } from '@syncfusion/ej2-angular-inputs';

@Directive({
  selector: '[notEmpty]'
})
export class NumericTextboxNotEmptyDirective {

  constructor(private el: ElementRef, private host: NumericTextBoxComponent) {}

  @HostListener('change', ['$event']) Change(args) {
    if (!args.isInteraction){
        return;
    }

    setTimeout(() => {
        if (!args.value){
            this.host.value = this._getMinValue(args);
        }
    }, 0);
  }

  private _getMinValue(args){
      if (args.previousValue !== null && args.previousValue !== undefined){
          return args.previousValue;
      } else if (this.host.min !== null && this.host.min !== undefined){
          return this.host.min;
      }

      return 0;
  }
}
