import { Directive, ElementRef, HostListener, Input } from '@angular/core';
import { DropDownListComponent } from '@syncfusion/ej2-angular-dropdowns';
import { Subscription } from 'rxjs';
import { ParticolareSearchService } from 'src/app/core/_services/particolare-search.service';

@Directive(
{
    selector: '[searchParticolariDDL]'
})
export class SearchParticolariDropDownListDirective
{
    private subscription = new Subscription();
    @Input() public codiceGruppo: string;

    constructor(private particolareSearchService: ParticolareSearchService, private elementRef: ElementRef, private host: DropDownListComponent)
    {
        host.allowFiltering = true;
        host.filterType = 'Contains';
    }

    @HostListener('filtering', ['$event']) Filtering(args)
    {
        this.subscription.add(this.particolareSearchService.searchParticolari(args.text, this.codiceGruppo).subscribe(o =>
        {
            if (!o)
                return;

            if (!this.host.value)
            {
                this.host.dataSource = o;
                return;
            }

            const dataSource = this.host.dataSource as Array<any>;
            const selectedIds = [ this.host.value ];
            const previousSelectedItems = dataSource.filter(n => selectedIds.find(m => m === n.Id));
            const newItems = o.filter(n => !previousSelectedItems.find(m => m.Id === n.Id));
            this.host.dataSource = [ ...newItems, ...previousSelectedItems ];
        }));
    }
}